<?php

namespace App\Connector\Controllers;

use App\Core\Controllers\BaseController;

class FulfillmentController extends BaseController
{
    public function fulfillmentNewAction()
    {
        $user_id = $this->di->getUser()->id;
        $userData = $this->di->getObjectManager()->get("\App\Core\Models\User\Details")
            ->getDataByUserID($user_id, 'mercado_cbt');
        $contentType = $this->request->getHeader('Content-Type');
        $rawBody = [];
        if (strpos($contentType, 'application/json') !== false) {
            $rawBody = $this->request->getJsonRawBody(true);
        }
        $cbtId = 'CBT1406775884';

        $handlerData = [
            'type' => 'full_class',
            'class_name' => '\App\Mercadohome\Models\Fulfillment',
            'method' => 'fulfillment',
            'queue_name' => 'ml_sync_fulfillment',
            'user_id' => $user_id,
            'userData' => $userData,
            'data' => [
                'cursor' => 1,
                'activePage' => 1,
                'target_marketplace' => $rawBody['target_marketplace'] ?? 'eyJtYXJrZXRwbGFjZSI6ImFsbCJ9',
            ]
        ];

        $rmqHelper = $this->di->getObjectManager()->get('\App\Rmq\Components\Helper');
        $rmqHelper->createQueue($handlerData['queue_name'], $handlerData);
        // $product = $this->di->getObjectManager()->get('\App\Mercadohome\Models\Fulfillment');
        // $res = $product->fulfillment($handlerData);
        // return $this->prepareResponse(['success' => true, 'message' => 'Initiate Fulfillment Sync','data'=>$res['data']]);
        return $this->prepareResponse(['success' => true, 'message' => 'Initiate Fulfillment Sync']);
    }
    public function fulfillmentAction()
    {
        $user_id = $this->di->getUser()->id;
        $userData = $this->di->getObjectManager()->get("\App\Core\Models\User\Details")
            ->getDataByUserID($user_id, 'mercado_cbt');
        $contentType = $this->request->getHeader('Content-Type');
        $rawBody = [];
        if (strpos($contentType, 'application/json') !== false) {
            $rawBody = $this->request->getJsonRawBody(true);
        }
        $cbtId = 'CBT1406775884';
        $handlerData = [
            'type' => 'full_class',
            'class_name' => '\App\Connector\Models\Fulfillment',
            'method' => 'fulfillment',
            'queue_name' => 'ml_sync_fulfillment',
            'user_id' => $user_id,
            'userData' => $userData,
            'data' => [
                'cursor' => 1,
                'activePage' => 1,
                'target_marketplace' => $rawBody['target_marketplace'] ?? 'eyJtYXJrZXRwbGFjZSI6ImFsbCJ9',
            ]
        ];
        $rmqHelper = $this->di->getObjectManager()->get('\App\Rmq\Components\Helper');
        $rmqHelper->createQueue($handlerData['queue_name'], $handlerData);

        return $this->prepareResponse(['success' => true, 'message' => 'Initiate Fulfillment Sync']);
    }
}
